# Code for LSM experiments in *The location of the axon initial segment affects the bandwidth of spike initiation dynamics*

## Requirements

* Python >= 3.5
* NEST 2.12
* NumPy (tested with 1.17.0)
* Matplotlib (tested with 3.1.3)
* Scikit-learn (tested with 0.21.2)

## Installing the NEST module

To build and install the required NEST module, run the *install.sh* script in
the *nest_module* subdirectory. This requires NEST to be set up properly with
all environment variables set.

## Generating the main results

This reproduces the results in Figure 7:

        python3 main_lsm_multirun.py --scenario opt_for_25um --num-seeds 50
        python3 main_plot_results.py --scenario opt_for_25um

Note that the data generation (first line) will take very long (i.e. up to multiple weeks), but can easily be parallelized (just run instances on multiple machines for different random seeds by changing the definition of *seed_* in *main_lsm_multirun.py*).

The second line generates a similar plot as shown in the paper.

## Generating the supplementary results

This reproduces the results in Supp. Figure 2 (the same notes apply):

        # Supp. Figure 2A
        python3 main_lsm_multirun.py --scenario opt_for_DeltaT2.5 --num-seeds 50
        python3 main_plot_results.py --scenario opt_for_DeltaT2.5

        # Supp. Figure 2B
        python3 main_lsm_multirun.py --scenario opt_for_equal_delays --num-seeds 50
        python3 main_plot_results.py --scenario opt_for_equal_delays

        # Supp. Figure 2C
        python3 main_lsm_multirun.py --scenario opt_for_0um --num-seeds 50
        python3 main_plot_results.py --scenario opt_for_0um
